// Unpack Install Maker

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


// Type Definitions for short types
typedef unsigned char	UINT8;
typedef signed char 	INT8;

typedef unsigned short	UINT16;
typedef signed short	INT16;

typedef unsigned int	UINT32;
typedef signed int		INT32;


int main(int argc, char* argv[]);
UINT8 UnpackInstallMaker(char* File, char* Path);
void UnpackFile(UINT8* Data, UINT32 DataLen, UINT8** OutBuf, UINT32* OutLen);


int main(int argc, char* argv[])
{
	char* InstallFile;
	char* ExtractPath;
	UINT8 RetVal;
	
	printf("Install Maker Extractor\n-----------------------\n");
	if (argc <= 0x02)
	{
		printf("Usage: IMExtract.exe InstMaker.exe ExtractPath\n");
		return 1;	// need a file
	}
	
	InstallFile = argv[0x01];
	ExtractPath = (char*)malloc(strlen(argv[0x02]) + 0x02);
	strcpy(ExtractPath, argv[0x02]);
	if (ExtractPath[strlen(ExtractPath) - 0x01] != '\\')
		strcat(ExtractPath, "\\");
	
	RetVal = UnpackInstallMaker(InstallFile, ExtractPath);
	
#ifdef _DEBUG
	getchar();
#endif
	
	return 0;
}

UINT8 UnpackInstallMaker(char* File, char* Path)
{
	FILE* hFile;
	UINT32 FileLen;
	UINT8* FileData;
	UINT32 OutLen;
	UINT8* OutBuf;
	UINT32 CurPos;
	UINT16* Int16Pnt;
	UINT32* Int32Pnt;
	UINT32 CurFile;
	char* OutFileName;
	UINT32 DataLen;
	UINT8 DataFound;
	
	hFile = fopen(File, "rb");
	if (hFile == NULL)
	{
		printf("Error: Can't open Installer EXE!\n");
		return 0x10;
	}
	
	fseek(hFile, 0x00, SEEK_END);
	FileLen = ftell(hFile);
	
	fseek(hFile, 0x00, SEEK_SET);
	FileData = (UINT8*)malloc(FileLen);
	fread(FileData, 0x01, FileLen, hFile);
	
	fclose(hFile);
	
	// Search for data
	Int16Pnt = (UINT16*)FileData;
	DataFound = 0x00;
	for (CurPos = 0x00; CurPos < FileLen; CurPos += 0x02, Int16Pnt ++)
	{
		if (*Int16Pnt == 0x7777)
		{
			Int32Pnt = (UINT32*)(&FileData[CurPos + 0x02]);
			if (*Int32Pnt == 0x48295467)
			{
				CurPos += 0x06;
				DataFound = 0x01;
				break;
			}
		}
	}
	if (! DataFound)
	{
		printf("Unable to find data! Is this really an Install Maker file??\n");
		return 0x40;
	}
	memcpy(&DataLen, &FileData[CurPos + 0x04], 0x04);
	if (DataLen)
	{
		// Install Creator
		printf("That seems to be an Install Creator file, which isn't supported.");
		return 0xF0;
	}
	memcpy(&CurPos, &FileData[CurPos + 0x00], 0x04);
	
	OutFileName = (char*)malloc(strlen(Path) + 0x10);
	do
	{
		memcpy(&CurFile, &FileData[CurPos + 0x00], 0x04);	// some sort of ID
		memcpy(&DataLen, &FileData[CurPos + 0x04], 0x04);
		CurPos += 0x08;
		if (CurFile == 0x00007F7F)
			CurPos += 0x04;
		
		printf("File %05X\n", CurFile);
		UnpackFile(&FileData[CurPos], DataLen, &OutBuf, &OutLen);
		
		sprintf(OutFileName, "%s%08X", Path, CurFile);
		strcat(OutFileName, ".cmp");
		
		hFile = fopen(OutFileName, "wb");
		if (hFile == NULL)
		{
			printf("Error: Can't open Output File!\n");
			return 0x80;
		}
		
		fwrite(OutBuf, 0x01, OutLen, hFile);
		fclose(hFile);
		
		free(OutBuf);
		
		CurPos += DataLen;
		if (CurFile == 0x00007F7F)
			break;
	} while(CurPos < FileLen);
	
	/*if (CurFile == 0x00007F7F)
	{
	}*/
	
	free(OutFileName);
	
	return 0x00;
}

void UnpackFile(UINT8* Data, UINT32 DataLen, UINT8** OutBuf, UINT32* OutLen)
{
	UINT32 CompLen;
	UINT32 UncompLen;
	
	CompLen = DataLen /*- 0x04*/;
	memcpy(&UncompLen, &Data[0x00], 0x04);
	
	printf("\tSize Compressed: %u, Uncompressed: %u\n", CompLen, UncompLen);
	
	*OutLen = DataLen;
	*OutBuf = (UINT8*)malloc(*OutLen);
	memcpy(*OutBuf, &Data[0x00], *OutLen);
	
	return;
}
